local metadata = {
"## Interface: FS15 1.3.0.1 1.3RC1",
"## Title: FarmSilo",
"## Notes: FarmSilo mit Capacity",
"## Author: Marhu",
"## Version: 1.0.1-187",
"## Date: 10.01.2016",
"## Web: http://marhu.net"
}
 
local DebugEbene = 0;
local function getmdata(v) v="## "..v..": "; for i=1,table.getn(metadata) do local _,n=string.find(metadata[i],v);if n then return (string.sub (metadata[i], n+1)); end;end;end;
print("Script "..(getmdata("Title")).." v"..(getmdata("Version")).." by "..(getmdata("Author")).." loaded! Support on "..(getmdata("Web")));
local function Debug(printDebug,...)
	if printDebug <= DebugEbene then
		local m,t,s,ts = "",type,select,tostring;
		for i = 1, s("#", ...) do if t(s(i, ...)) == "boolean" then m = m..(s(i, ...) and "true" or "false").." "; else m = m..ts(s(i, ...) or "nil").." "; end; end;
		print((getmdata("Title")).." v"..(getmdata("Version"))..": "..m);
end; end;

FarmSilo = {};
local FarmSilo_mt = Class(FarmSilo, Object);
InitObjectClass(FarmSilo, "FarmSilo");

function FarmSilo.onCreate(id)
	local object = FarmSilo:new(g_server ~= nil, g_client ~= nil)
	if object:load(id) then
		g_currentMission:addOnCreateLoadedObject(object);
		g_currentMission:addOnCreateLoadedObjectToSave(object);
        object:register(true);
		Debug(1,string.format("onCreate(%d) load %s",id,getName(id)));
    else
        object:delete();
		Debug(-1,string.format("ERROR: onCreate(%d) delete %s",id,getName(id)));
    end;
end;

function FarmSilo:new(isServer, isClient, customMt)
  
	local mt = customMt;
    if mt == nil then
        mt = FarmSilo_mt;
    end;

	local self = Object:new(isServer, isClient, mt);

	self.nodeId = 0;
	self.fillLevel = {}
	
	self.FarmSiloDirtyFlag = self:getNextDirtyFlag();

	return self;
 
end;

function FarmSilo:load(id) 
  
	self.nodeId = id;
	self.Name = getName(id)
	self.capacity = Utils.getNoNil(getUserAttribute(id, "capacity"),100000);
	self.Indicators = {};
	self.IndicatorsIcon = {}
	local IndicatorGru = Utils.indexToObject(id, getUserAttribute(id, "Indicator"));
	
	local TipTriggerIndex = getUserAttribute(id, "TipTriggerIndex");
	local SiloTriggerIndex = getUserAttribute(id, "SiloTriggerIndex");
	local tipTrigger = Utils.indexToObject(id, TipTriggerIndex);
	local siloTrigger = Utils.indexToObject(id, SiloTriggerIndex);
		
	if tipTrigger ~= nil then
		if siloTrigger ~= nil then
			self.TipTriggerId = tipTrigger;
			self.SiloTriggerId = siloTrigger;
			local lvl = getUserAttribute(id, "fillLevel");
			local syncSiloAmount = Utils.getNoNil(getUserAttribute(id, "SiloAmount"),true);
			if self.isServer and syncSiloAmount == true then
				local function setSiloAmount(g_cM, fillType, siloAmount)
					self.UpdateSiloAmount = 10000;
				end
				g_currentMission.setSiloAmount = Utils.appendedFunction(g_currentMission.setSiloAmount, setSiloAmount)
			end
			local indicNum = 0;
			local maxIndicators = getNumOfChildren(IndicatorGru);
			local fillTypes = getUserAttribute(tipTrigger, "fillTypes")
			if fillTypes == nil then
				fillTypes = getUserAttribute(tipTrigger, "fruitTypes")
			end
			if fillTypes ~= nil then
				local types = Utils.splitString(" ", fillTypes)
				for k, v in pairs(types) do
					local desc = Fillable.fillTypeNameToDesc[v]
					if desc ~= nil then
						self.fillLevel[desc.index] = lvl or g_currentMission:getSiloAmount(desc.index);
						if maxIndicators > indicNum then
							local indic = getChildAt(IndicatorGru,indicNum)
							self.Indicators[desc.index] = {}
							
							local hudIndex = getUserAttribute(indic, "hudIndex") 
							if hudIndex ~= nil and hudIndex ~= "" then
								self.Indicators[desc.index].hud = Utils.indexToObject(indic, hudIndex);
								local materialId, isDefault = Fillable.getFillMaterial(desc.index, 2, 1);
								setMaterial(self.Indicators[desc.index].hud, materialId);
							end
							local scalIndex = getUserAttribute(indic, "scaleIndex") 
							if scalIndex ~= nil and scalIndex ~= "" then
								self.Indicators[desc.index].scal = Utils.indexToObject(indic, scalIndex);
							end
							local dispIndex = getUserAttribute(indic, "displayIndex") 
							if dispIndex ~= nil and dispIndex ~= "" then
								self.Indicators[desc.index].disp = Utils.indexToObject(indic, dispIndex);
							end
							indicNum = indicNum + 1
						end
					else
						Debug(-1,string.format("ERROR: %s invalid fillTypes %s in TipTrigger",self.Name,tostring(v)));
					end
				end
			else
				Debug(-1,string.format("ERROR: %s can not find fillTypes in TipTrigger",self.Name));
			end
		else
			Debug(-1,string.format("ERROR: %s SiloTriggerIndex %s not exist",self.Name,tostring(SiloTriggerIndex)));
			return false;
		end
	else
		Debug(-1,string.format("ERROR: %s TipTriggerIndex %s not exist",self.Name,tostring(TipTriggerIndex)));
		return false;
	end
	
	if not g_FarmSiloSiloDialog then
		g_FarmSiloSiloDialog = MultiSiloDialog:new()
		g_FarmSiloSiloDialog.fillTypesOnClick = self.siloDialog_fillTypesOnClick
		g_FarmSiloSiloDialog.setFillTypes     = self.siloDialog_setFillTypes
		g_gui:loadGui("dataS/gui/MultiSiloDialog.xml", "FarmSiloSiloDialog", g_FarmSiloSiloDialog)
	end
	
	self.sendWarning = false;
	
	return true;
end;
  
function FarmSilo:delete()

end;

function FarmSilo:getSaveAttributesAndNodes(nodeIdent)
	
	local attributes, nodes = "","";
			
	for k,v in pairs (self.fillLevel) do
		if 0 < nodes.len(nodes) then
			nodes = nodes .. "\n"
		end
		local name = Fillable.fillTypeIntToName[k];
		nodes = nodes..nodeIdent..'<FillLevel Name="'..name..'" Lvl="'..v..'"/>';
	end
	  
    return attributes,nodes;
end

function FarmSilo:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	
	local i = 0
	while true do
		local LevelKey = key .. string.format(".FillLevel(%d)", i)
		if not hasXMLProperty(xmlFile, LevelKey) then
			break
		end

		local Name = getXMLString(xmlFile, LevelKey .. "#Name")
		local fillLevel = getXMLFloat(xmlFile, LevelKey .. "#Lvl")
		local desc = Fillable.fillTypeNameToDesc[Name]

		if desc ~= nil and fillLevel ~= nil and self.fillLevel[desc.index] ~= nil then
			local oldLvl = self:getFillLevel(desc.index);
			self:setFillLevel(desc.index, -oldLvl+fillLevel)
		end
		i = i + 1
	end	
	Debug(1,string.format("%s loadFromAttributesAndNodes",self.Name));
	return true;
end

function FarmSilo:writeStream(streamId, connection)
	if not connection:getIsServer() then
		for k,v in pairs (self.fillLevel) do
			streamWriteInt16(streamId, k)
			streamWriteFloat32(streamId, v)
		end
    end;
end; 

function FarmSilo:readStream(streamId, connection)
	if connection:getIsServer() then
		for k,v in pairs (self.fillLevel) do
			local id = streamReadInt16(streamId)
			local lvl = streamReadFloat32(streamId)
			self:setFillLevel(id, lvl)
		end
	end;
end;

function FarmSilo:writeUpdateStream(streamId, connection, dirtyMask)
	if not connection:getIsServer() then
		streamWriteBool(streamId, self.sendWarning)
		self.sendWarning = false;
		for k,v in pairs (self.fillLevel) do
			streamWriteInt16(streamId, k)
			streamWriteFloat32(streamId, v)
		end
	end;
end;
 
function FarmSilo:readUpdateStream(streamId, timestamp, connection)
	if connection:getIsServer() then
		local warning = streamReadBool(streamId)
		if warning == true then self.WarningTime = 2000; end;
		for k,v in pairs (self.fillLevel) do
			local id = streamReadInt16(streamId)
			local lvl = streamReadFloat32(streamId)
			Debug(2,string.format("%s readUpdateStream %d %.3f",self.Name,id,lvl));
			local old_Lvl = self:getFillLevel(id)
			self:setFillLevel(id, lvl-old_Lvl)
		end;
	end;
end;

function FarmSilo:update(dt)
	if not self.init then self.init = true; self:findTrigger() end
	
	if self.WarningTime then
		self.WarningTime = self.WarningTime - dt
		if self.WarningTime < 0 then self.WarningTime = nil; end;
		if g_currentMission.currentTipTrigger ~= nil 
		and g_currentMission.currentTipTrigger.rootNode == self.TipTriggerId 
		and g_currentMission.trailerInTipRange ~= nil
		and g_currentMission.trailerInTipRange.attacherVehicle ~= nil 
		and g_currentMission.trailerInTipRange.attacherVehicle == g_currentMission.controlledVehicle then
			g_currentMission:showBlinkingWarning(g_i18n:getText("Here_is_no_space"));
		end
	end	
end;

function FarmSilo:updateTick(dt)
	if self.UpdateSiloAmount ~= nil then
		self.UpdateSiloAmount = self.UpdateSiloAmount - dt;
		if self.UpdateSiloAmount <= 0 then
			self.UpdateSiloAmount = nil;
			Debug(10,string.format(" %s UpdateSiloAmount",self.Name));
			for k,v in pairs (self.fillLevel) do
				local siloAmount = g_currentMission:getSiloAmount(k)
				if siloAmount ~= v then
					self:setFillLevel(k, -v + siloAmount)
				end
			end
		end
	end
	if self.isServer and self.SendUpdate then
		self.SendUpdate = nil
		self:raiseDirtyFlags(self.FarmSiloDirtyFlag);
	end;
end;

function FarmSilo:siloDialog_setFillTypes(fillTypes)
	self.fillTypes = fillTypes
	local fillTypesTable = {}

	for _, fillType in pairs(fillTypes) do
		local name = Fillable.fillTypeIndexToDesc[fillType].nameI18N
		name = string.format("%s %d %s", name, g_i18n:getFluid(self.FarmSilo:getFillLevel(fillType)), g_i18n:getText("fluid_unit_short"))

		table.insert(fillTypesTable, name)
	end

	self.fillTypesElement:setTexts(fillTypesTable)
	self.fillTypesElement:setState(self.selectedState)
	self.fillTypesOnClick(self, self.selectedState)
end

function FarmSilo:siloDialog_fillTypesOnClick(state)
	Debug(1,string.format("%s siloDialog_fillTypesOnClick",self.FarmSilo.Name));
	self.messageText:setText("")
	self.messageBackground:setVisible(false)
	self:setButtonDisabled(false)
	
	local i = 1
	for _, fillType in pairs(self.fillTypes) do
		if i == state then
			self.selectedFillType = fillType
			break
		end
		i = i + 1
	end
	
	self.selectedState = state
	local siloAmount = self.FarmSilo:getFillLevel(self.selectedFillType) 

	if siloAmount <= 0 then
		self.messageText:setText(g_i18n:getText("siloIsEmpty"))
		self.messageBackground:setVisible(true)
		self:setButtonDisabled(true)
	end
end

function FarmSilo:siloTrigger_update(superFunc, dt)
	local oldTrailerFillLevel = 0;
	
	if self.isServer then
		local trailer = self.siloTrailer
		if 4 <= self.fill and trailer ~= nil then
			if self.isFilling then
				oldTrailerFillLevel = trailer.getFillLevel(trailer, self.selectedFillType)
				Debug(2,string.format("%s isFilling pre trailer Lvl: %.2f",self.FarmSilo.Name,oldTrailerFillLevel));
			end
		end
	end
	
	superFunc(self, dt)
	
	if self.isServer then
		local trailer = self.siloTrailer
		if 4 <= self.fill and trailer ~= nil then
			if self.isFilling then
				local fillLevel = trailer.getFillLevel(trailer, self.selectedFillType)
				local delta = oldTrailerFillLevel-fillLevel;
				local SiloLvl = self.FarmSilo:getFillLevel(self.selectedFillType);
				if SiloLvl + delta < 0 then
					local diff = SiloLvl + delta
					trailer.setFillLevel(trailer, fillLevel + diff, self.selectedFillType)
					local siloAmount = g_currentMission:getSiloAmount(self.selectedFillType)
					g_currentMission:setSiloAmount(self.selectedFillType, siloAmount - diff)
					delta = -SiloLvl;
					self:setIsFilling(false, Fillable.FILLTYPE_UNKNOWN)
				end
				self.FarmSilo:setFillLevel(self.selectedFillType, delta)
				Debug(2,string.format("%s isFilling post trailer Lvl: %.2f dif: %.2f",self.FarmSilo.Name,fillLevel,delta));
			end
		end
	end
end

function FarmSilo:siloTriggerget_isActivatable(superFunc)
	local activatable = superFunc(self)
	Debug(2,string.format("%s siloTriggerget_isActivatable",self.FarmSilo.Name));
	if activatable and not self.isFilling and self.siloTrailer ~= nil then
		local trailer = self.siloTrailer
		if trailer.fillLevel > 0 and self.FarmSilo:getFillLevel(trailer.currentFillType) <= 0 then
			return false
		end
	end
	return activatable
end

function FarmSilo:siloTrigger_onActivateObject(superFunc)
	
	if not self.isFilling then
        if self.siloTrailer ~= nil and self.siloTrailer.fillLevel > 0 then
            self:setIsFilling(true, self.siloTrailer.currentFillType);
        else
			g_FarmSiloSiloDialog.FarmSilo = self.FarmSilo;
		    g_FarmSiloSiloDialog:setFillTypes(self.fillTypes);
            g_FarmSiloSiloDialog:setTitle(self.stationName);
            g_FarmSiloSiloDialog:setSelectionCallback(self.onFillTypeSelection, self);
            self.multiSiloDialog = g_gui:showGui("FarmSiloSiloDialog");
		end;
    else
        self:setIsFilling(false, Fillable.FILLTYPE_UNKNOWN);
    end;
	g_currentMission:addActivatableObject(self);
	Debug(2,string.format("%s siloTrigger_onActivateObject",self.FarmSilo.Name));
	
end

function FarmSilo:findTrigger(dt)
	local findTipTrigger, findSiloTrigger = false,false;
	for k,v in pairs(g_currentMission.onCreateLoadedObjects) do
		if v.rootNode == self.TipTriggerId then
			v:addUpdateEventListener(self); --self.onUpdateEvent
			Debug(1,string.format("%s find TipTrigger in g_currentMission.onCreateLoadedObjects",self.Name));
			findTipTrigger = true;
		elseif v.rootNode == self.SiloTriggerId then
			v.FarmSilo = self;
			v.update           = Utils.overwrittenFunction(v.update,           FarmSilo.siloTrigger_update)
			v.isActivatable    = Utils.overwrittenFunction(v.isActivatable,    FarmSilo.siloTrigger_isActivatable)
			v.onActivateObject = Utils.overwrittenFunction(v.onActivateObject, FarmSilo.siloTrigger_onActivateObject)
			Debug(1,string.format("%s find SiloTrigger in g_currentMission.onCreateLoadedObjects",self.Name));
			findSiloTrigger = true
			for k,v in pairs (self.fillLevel) do
				if self.Indicators[k] then
					if self.Indicators[k].hud then
						local materialId, isDefault = Fillable.getFillMaterial(k, 2, 1);
						setMaterial(self.Indicators[k].hud, materialId);
						setShaderParameter(self.Indicators[k].hud,"iconColor",0.6,0.6,0.6,1,false)	
					end
					if self.Indicators[k].scal then
						setScale(self.Indicators[k].scal, 1, math.min(1,self.fillLevel[k]/self.capacity), 1)
					end
					if self.Indicators[k].disp then
						Utils.setNumberShaderByValue(self.Indicators[k].disp, math.floor(self.fillLevel[k]), 0, true)
					end
				end
			end
		end
		if findTipTrigger and findSiloTrigger then
			return;
		end
	end
	if not findTipTrigger then
		Debug(-1,string.format("ERROR: %s TipTrigger not exist in g_currentMission.onCreateLoadedObjects",self.Name));
	end
	if not findSiloTrigger then
		Debug(-1,string.format("ERROR: %s SiloTrigger not exist in g_currentMission.onCreateLoadedObjects",self.Name));
	end
end;

function FarmSilo:onUpdateEvent(tipTrigger, fillDelta, fillType, trailer)
	local fillTypeName = Fillable.fillTypeIntToName[fillType];
	local desc = Fillable.fillTypeIndexToDesc[fillType];
	if desc ~= nil then fillTypeName = desc.nameI18N end
	Debug(1,string.format("%s onUpdateEvent fillType %s %.2f",self.Name,fillTypeName,fillDelta));
	local SiloLvl = self:getFillLevel(fillType);
	if SiloLvl-fillDelta > self.capacity then
		local diff = math.min((SiloLvl-fillDelta) - self.capacity,-fillDelta)
		local fillLevel = trailer.getFillLevel(trailer, fillType)
		if fillLevel + diff <= 0.001 then diff = 0; end;
		trailer.setFillLevel(trailer, fillLevel + diff, fillType)
		local siloAmount = g_currentMission:getSiloAmount(fillType)
		g_currentMission:setSiloAmount(fillType, siloAmount - diff)
		fillDelta = fillDelta + diff
		trailer:onEndTip()
		self.WarningTime = 2000;
		self.sendWarning = true;
	end;
	self:setFillLevel(fillType,-fillDelta)
end

function FarmSilo:getFillLevel(fillType)
	if self.fillLevel[fillType] then
		return self.fillLevel[fillType];
	end
	return 0;
end

function FarmSilo:setFillLevel(fillType,fillDelta)
	local fillTypeName = Fillable.fillTypeIntToName[fillType];
	local desc = Fillable.fillTypeIndexToDesc[fillType];
	if desc ~= nil then fillTypeName = desc.nameI18N end
	
	if self.fillLevel[fillType] then
		self.fillLevel[fillType] = self.fillLevel[fillType] + fillDelta;
		self.SendUpdate = true;
		if self.Indicators[fillType] then
			if self.Indicators[fillType].scal then
				setScale(self.Indicators[fillType].scal, 1, math.min(1,self.fillLevel[fillType]/self.capacity), 1)
			end
			if self.Indicators[fillType].disp then
				Utils.setNumberShaderByValue(self.Indicators[fillType].disp, math.floor(self.fillLevel[fillType]), 0, true)
			end
		end
		Debug(1,string.format("%s fillType %s lvl %.2f",self.Name,fillTypeName,self.fillLevel[fillType]));
	else
		Debug(-1,string.format("ERROR: %s fillType %s not in table self.fillLevel",self.Name,fillTypeName));
	end
end

g_onCreateUtil.addOnCreateFunction("FarmSilo", FarmSilo.onCreate);
 
